// import Event from './event.js'
// var pako = window.pako
var socket = {
	socket: null, // socket name
	realTimeData: null, // 请求实时数据的参数
	intervalObj: null, // 定时器的名字
	lastRealTimeData: null, // 上一次请求的产品
	sendData(historyData, realTimeDatas, history) {
		// console.log(historyData)
		// 储存历史数据
		this.historyData = historyData
		this.realTimeData = realTimeDatas
		var newData = new Array(); //定义一数组
		newData = this.realTimeData.split("."); //字符分割
		// 如果上一次订阅过产品
		if (this.lastRealTimeData) {
			var oldData = new Array(); //定义一数组
			oldData = this.lastRealTimeData.split("."); //字符分割
			// 如果不是订阅历史产品 那么肯定就是切换周期咯 或者 切换产品
			// 那么就取消订阅上一次的产品实时数据
			if (!history) {
				Event.emit('zhezhaoceng', 1)
				console.log('取消币种' + oldData[1])
				console.log('取消分钟线' + oldData[3])
				this.sendWsRequest({
					'subs': 'tradenow',
					"user_id": "",
					"unsub": this.lastRealTimeData,
					"id": "BTC"
				})
				// this.sendWsRequest({
				// 	'subs':'tradenow',
				// 	"user_id":"",
				// 	"unsub": oldData[0] + "." + oldData[1] + "." + oldData[2] + ".1day",
				// 	"id": "BTC"
				// })
			}

			// 如果不是订阅历史产品 那么肯定就是切换周期咯 或者切换产品咯 
			// 那么就订阅一下 这次产品的或者周期的 实时数据
			if (!history) {
				console.log('订阅新的币种：' + newData[1])
				console.log('订阅新的分钟线：' + newData[3])

				this.lastRealTimeData = this.realTimeData
				if (bb_type == 2) {
					// Event.emit('reconnect', newData[3])
				} else {
					// 请求这一次的历史
					this.sendWsRequest({
						'subs': 'history',
						"sub": this.lastRealTimeData,
						"period": newData[3],
						'symbol': newData[1],
						'size': "900",
						"id": "BTC"
					})
				}
				this.sendWsRequest({
					'subs': 'tradenow',
					"user_id": "",
					"sub": this.lastRealTimeData,
					"id": "BTC"
				})
				// this.sendWsRequest({
				// 	'subs':'tradenow',
				// 	"user_id":"",
				// 	"sub": newData[0] + "." + newData[1] + "." + newData[2] + ".1day",
				// 	"id": "BTC"
				// })
			}
		} else {
			Event.emit('changeflag', false)
			// 如果是第一次订阅，就是说刚进入交易所，
			// 先存起来这一次请求的产品 作为历史产品
			this.lastRealTimeData = this.realTimeData
			// 然后 初始化一下websocket
			this.initWs()
		}
	},
	initWs() {
		// this.socket = new WebSocket('ws://47.57.137.10:17878')
		this.socket = new WebSocket('wss://wss.bitwealth1.com:17878')
		this.socket.onopen = () => {

			var oldData = new Array(); //定义一数组
			oldData = this.historyData.req.split("."); //字符分割
			// 如果是aptusdt币种，在WebSocket里拿不到历史数据，需要用定时请求拿数据 看kline.js里的 getHistory()方法
			if (bb_type == 1) {
				this.sendWsRequest({
					'subs': 'history',
					"sub": this.historyData.req,
					"period": oldData[3],
					'symbol': oldData[1],
					'size': "900",
					"id": "BTC"
				})
			}
			this.sendWsRequest({
				'subs': 'tradenow',
				"user_id": "",
				"sub": this.historyData.req,
				"id": "BTC"
			})
			// this.sendWsRequest({
			// 	'subs':'tradenow',
			// 	"user_id":"",
			// 	"sub": oldData[0] + "." + oldData[1] + "." + oldData[2] + ".1day",
			// 	"id": "BTC"
			// })
			this.sendWsRequest({
				'subs': 'depth',
				"user_id": "",
				"sub": "market." + oldData[1] + ".depth.step0",
				"id": "BTC",
			})
		}
		this.socket.onmessage = resp => {
			this.message(resp)
		}
		this.socket.onclose = () => {
			this.close()
		}
		this.socket.onerror = err => {
			this.error(err)
		}
	},
	error(err) {
		console.log(err, 'depth-socket::error')
	},
	close() {
		// 如果websocket关闭的话，就从新打开一下。
		this.initWs()
		console.log('depth-socket::close')
	},
	message(resp) {
		// console.log(resp)
		let this_ = this
		let msg = JSON.parse(resp.data)
		// console.log(msg)
		if (msg.subs == "depth") {
			Event.emit('depth', msg.tick)
		} else {
			// 如果是实时数据触发Event('realTime') 喂数据
			// console.log('实时数据1',msg)
			// console.log(this.lastRealTimeData)
			if (msg.tick) {
				if (msg.ch == this.lastRealTimeData) {
					// console.log(msg.ch)
					// console.log('实时数据' ,msg.tick)
					Event.emit('realTime', msg.tick)
					Event.emit('newData', msg.tick)
					lastminClose = msg.tick.close
				}
			}
			if (msg.ch && msg.subs != "history") {
				if (msg.ch.slice(-4) == "1day") {
					// console.log('一天的数据',msg.tick)
					Event.emit('newDay', msg.tick)
				}
			}

			//响应服务器，避免断开连接
			if (msg.ping) {
				this_.socket.send(JSON.stringify({
					pong: msg.ping
				}));
				this_.hasCheck = true
			}
			this_.lastRealTimeData = this_.realTimeData
			// 如果是历史数据触发Event('data') 绘制数据
			if (msg.data && Array.isArray(msg.data)) {
				Event.emit('data', msg.data)
				Event.emit('newData', msg.data[msg.data.length - 1])
				// console.log(msg.data)
			}
		}

		// }
		// // //将返回的数据解析为字符串格式
		// reader.readAsArrayBuffer(resp.data);
	},
	checkSendMessage(options) {
		// 这里处理websocket 连接不上的问题
		var checkTimes = 10
		var i = 0
		this.intervalObj = setInterval(() => {
			i += 1
			if (this.socket.readyState === 1) {
				// ...
				this.socket.send(options)
				clearInterval(this.intervalObj)
				return
			}
			if (i >= checkTimes) {
				clearInterval(this.intervalObj)
				console.log('send post_data_str timeout.')
			}
		}, 500)
	},
	sendWsRequest(options) {
		// console.log(options)
		switch (this.socket.readyState) {
			case 0:
				console.log('ws状态0')
				this.checkSendMessage(JSON.stringify(options))
				break
			case 1:
				console.log('ws状态1')
				console.log(JSON.stringify(options))
				// var user_id = ""
				// if(window.localStorage.getItem("user_id")){
				// 	user_id = JSON.parse(window.localStorage.getItem("user_id")).data
				// }else{
				// 	user_id = JSON.parse(plus.storage.getItem("user_id")).data
				// }
				// options.user_id = user_id
				this.socket.send(JSON.stringify(options))
				break
			case 2:
				console.log('ws关闭状态')
				break
			case 3:
				console.log('ws状态3')
				this.initWs()
				break
			default:
				console.log('ws未知错误')
		}
	}
}

// export default socket
